//
//  SHNotifiction.h
//  keyiDownloadFramework
//
//  Created by moyanjwb on 14-3-3.
//  Copyright (c) 2014年 moyanjwb. All rights reserved.
//

#import <Foundation/Foundation.h>

//通知对象定义
@interface SHNotifiction : NSObject
@property (retain) id        param1;
@property (retain) id        param2;
@property (retain) id        param3;
@property (assign) long      cmdId;
+(id)initWithParam:(long)cmdId;
+(id)initWithParam:(long)cmdId param1:(id)param1;
+(id)initWithParam:(long)cmdId param1:(id)param1 param2:(id)param2;
+(id)initWithParam:(long)cmdId param1:(id)param1 param2:(id)param2 param3:(id)param3;
@end


//通知协议
@protocol SHNotifictionProtocol <NSObject>
@optional
-(BOOL)onNotifiction:(SHNotifiction*)notifiction;
@end

//
void registerNotifiction(id<SHNotifictionProtocol> obj);
void unRregisterNotifiction(id<SHNotifictionProtocol> obj);
BOOL fireNotifiction(SHNotifiction* notifiction);
